<template>
  <crud-data-table-delete
    v-model="dialog"
    :entity-being-deleted="$t('paymentRecurrence')"
    :item-being-deleted="paymentRecurrenceBeingDeleted"
    :loading="isLoading"
    @onAgree="onAgree"
    @onDisagree="onDisagree"
  />
</template>

<script>
  export default {
    name: 'DeletePaymentRecurrenceDialog',
    data () {
      return {
        dialog: false,
        isLoading: false,
        paymentRecurrenceBeingDeleted: {},
      }
    },
    created () {
      this.$emit('onDeletePaymentRecurrence', this.onDeletePaymentRecurrence)
    },
    methods: {
      onDeletePaymentRecurrence (paymentRecurrence) {
        this.paymentRecurrenceBeingDeleted = paymentRecurrence
        this.dialog = true
      },
      onAgree () {
        this.isLoading = true
        this.$store.dispatch('paymentRecurrences/deletePaymentRecurrence', {
          ID: this.paymentRecurrenceBeingDeleted.id,
        })
          .then(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'success',
              text: this.$t('deleteSuccess'),
            })
          })
          .catch(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'error',
              text: this.$t('deleteError'),
            })
          })
          .finally(() => {
            this.dialog = false
            this.isLoading = false
          })
      },
      onDisagree () {
        this.dialog = false
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          paymentRecurrence: 'Recorrência',
          deleteSuccess: 'Recorrência excluída com sucesso!',
          deleteError: 'Ops... Algo deu errado ao tentar excluir a recorrência. Por favor, tente novamente.',
        },
        'en-US': {
          paymentRecurrence: 'Payment recurrence',
          deleteSuccess: 'Payment recurrence successfully deleted!',
          deleteError: 'Oops... Something went wrong while trying to delete the payment recurrence. Please try again.',
        },
      },
    },
  }
</script>
